#!/bin/zsh

# Copyright 2016 Paul Hänsch
#
# This file is part of Confetti.
# 
# Confetti is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Confetti is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with Confetti.  If not, see <http://www.gnu.org/licenses/>. 

BR='
'
prescription="${_POST[prescription]}"

tempfile="$_DATA/temp/$prescription"
prescfile="$_DATA/prescriptions/$prescription"
client="${prescription%.*.mpx}.vcf"
clientfile="$_DATA/vcard/$client"

if [ -z "$prescription" -o \! -f "$clientfile" ]; then
  redirect "?p=error"
  exit 0
fi

# serialize POST array into file
for key in ${(k)_POST}; do
  printf %s:%s\\n "$key" "${_POST[$key]//$BR/\\n}"
done >"$tempfile"

case "${_POST[action]}" in
  save)
    mv "$tempfile" "$prescfile"
    touch "$clientfile"
    ;;
  cancel)
    rm "$tempfile"
    ;;
  delete)
    rm "$tempfile" "$prescfile"
    touch "$clientfile"
    ;;
esac

redirect "?p=prescriptions&client=${client}#${prescription}"
